diff --git a/src/app/gps/qgsgpsinformationwidget.cpp b/src/app/gps/qgsgpsinformationwidget.cpp
index ab9bc1e..56465f9 100644
--- a/src/app/gps/qgsgpsinformationwidget.cpp
+++ b/src/app/gps/qgsgpsinformationwidget.cpp
@@ -535,6 +775,8 @@ void QgsGPSInformationWidget::addVertex( )
   // calling close feature
   mCaptureList.push_back( mLastGpsPosition );
   // we store the rubber band points in map canvas CRS so transform to map crs
+  // potential problem with transform errors and wrong coordinates if map CRS is changed after points are stored - SLM
+  // should catch map CRS change and transform the points
   QgsPoint myPoint;
   if ( mpCanvas && mpCanvas->mapRenderer() )
   {
@@ -550,53 +792,50 @@ void QgsGPSInformationWidget::addVertex( )
 
 void QgsGPSInformationWidget::on_mBtnResetFeature_clicked( )
 {
-  mNmea->disconnect();
-  if ( mpRubberBand )
-  {
-    delete mpRubberBand;
-    mpRubberBand = 0;
-  }
-  createRubberBand( );
+  mNmea->disconnect( this, SLOT( displayGPSInformation( const QgsGPSInformation& ) ) );
+  createRubberBand( ); //deletes existing rubberband
   mCaptureList.clear();
   connectGpsSlot();
 }
 
 void QgsGPSInformationWidget::on_mBtnCloseFeature_clicked( )
 {
-  mNmea->disconnect();
   QgsVectorLayer *vlayer = qobject_cast<QgsVectorLayer *>( mpCanvas->currentLayer() );
+  QGis::WkbType layerWKBType = vlayer->wkbType();
 
   // -------------- preconditions ------------------------
+  // most of these preconditions are already handled due to the button being enabled/disabled based on layer geom type and editing capabilities, but not on valid GPS data
+#if 0
   if ( !vlayer )
   {
     QMessageBox::information( 0, tr( "Not a vector layer" ),
                               tr( "The current layer is not a vector layer" ) );
-    connectGpsSlot();
     return;
   }
   QGis::WkbType layerWKBType = vlayer->wkbType();
 
   //no support for adding features to 2.5D types yet
-  if ( layerWKBType == QGis::WKBLineString25D || layerWKBType == QGis::WKBPolygon25D ||
-       layerWKBType == QGis::WKBMultiLineString25D || layerWKBType == QGis::WKBPoint25D || layerWKBType == QGis::WKBMultiPoint25D )
+  if ( layerWKBType == QGis::WKBPoint25D ||
+       layerWKBType == QGis::WKBLineString25D ||
+       layerWKBType == QGis::WKBPolygon25D ||
+       layerWKBType == QGis::WKBMultiPoint25D ||
+       layerWKBType == QGis::WKBMultiLineString25D ||
+       layerWKBType == QGis::WKBMultiPolygon25D )
   {
     QMessageBox::critical( 0, tr( "2.5D shape type not supported" ), tr(
                              "Adding features to 2.5D shapetypes is not supported yet. Please "
                              "select a different editable, non 2.5D layer and try again." ) );
-    connectGpsSlot();
     return;
   }
 
   // Multipart features not supported
-  if ( layerWKBType == QGis::WKBMultiLineString ||
-       layerWKBType == QGis::WKBMultiPoint ||
+  if ( layerWKBType == QGis::WKBMultiPoint ||
        layerWKBType == QGis::WKBMultiLineString ||
        layerWKBType == QGis::WKBMultiPolygon )
   {
     QMessageBox::critical( 0, tr( "Multipart shape type not supported" ), tr(
                              "Adding features to multipart shapetypes is not supported yet. Please "
                              "select a different editable, non 2.5D layer and try again." ) );
-    connectGpsSlot();
     return;
 
   }
@@ -607,7 +846,6 @@ void QgsGPSInformationWidget::on_mBtnCloseFeature_clicked( )
   {
     QMessageBox::information( 0, tr( "Layer cannot be added to" ),
                               tr( "The data provider for this layer does not support the addition of features." ) );
-    connectGpsSlot();
     return;
   }
 
@@ -616,16 +854,15 @@ void QgsGPSInformationWidget::on_mBtnCloseFeature_clicked( )
     QMessageBox::information( 0, tr( "Layer not editable" ),
                               tr( "Cannot edit the vector layer. Use 'Toggle Editing' to make it editable." )
                             );
-    connectGpsSlot();
     return;
   }
+#endif
 
   //lines: bail out if there are not at least two vertices
   if ( layerWKBType == QGis::WKBLineString  && mCaptureList.size() < 2 )
   {
     QMessageBox::information( 0, tr( "Not enough vertices" ),
                               tr( "Cannot close a line feature until it has at least two vertices." ) );
-    connectGpsSlot();
     return;
   }
 
@@ -634,7 +871,6 @@ void QgsGPSInformationWidget::on_mBtnCloseFeature_clicked( )
   {
     QMessageBox::information( 0, tr( "Not enough vertices" ),
                               tr( "Cannot close a polygon feature until it has at least three vertices." ) );
-    connectGpsSlot();
     return;
   }
   // -------------- end of preconditions ------------------------
@@ -644,42 +880,53 @@ void QgsGPSInformationWidget::on_mBtnCloseFeature_clicked( )
   //
   if ( layerWKBType == QGis::WKBPoint )
   {
-    //only do the rest for provider with feature addition support
-    //note that for the grass provider, this will return false since
-    //grass provider has its own mechanism of feature addition
-    if ( provider->capabilities() & QgsVectorDataProvider::AddFeatures )
-    {
-      QgsFeature* f = new QgsFeature( 0, "WKBPoint" );
-
-      int size = 0;
-      char end = QgsApplication::endian();
-      unsigned char *wkb = NULL;
-      int wkbtype = 0;
+    QgsFeature* f = new QgsFeature( 0, "WKBPoint" );
 
-      QgsCoordinateTransform t( mWgs84CRS, vlayer->crs() );
-      QgsPoint myPoint = t.transform( mLastGpsPosition );
-      double x = myPoint.x();
-      double y = myPoint.y();
+    int size = 0;
+    char end = QgsApplication::endian();
+    unsigned char *wkb = NULL;
+    int wkbtype = 0;
 
-      size = 1 + sizeof( int ) + 2 * sizeof( double );
-      wkb = new unsigned char[size];
-      wkbtype = QGis::WKBPoint;
-      memcpy( &wkb[0], &end, 1 );
-      memcpy( &wkb[1], &wkbtype, sizeof( int ) );
-      memcpy( &wkb[5], &x, sizeof( double ) );
-      memcpy( &wkb[5] + sizeof( double ), &y, sizeof( double ) );
+    QgsCoordinateTransform t( mWgs84CRS, vlayer->crs() );
+    QgsPoint myPoint = t.transform( mLastGpsPosition );
+    double x = myPoint.x();
+    double y = myPoint.y();
 
-      f->setGeometryAndOwnership( &wkb[0], size );
+    size = 1 + sizeof( int ) + 2 * sizeof( double );
+    wkb = new unsigned char[size];
+    wkbtype = QGis::WKBPoint;
+    memcpy( &wkb[0], &end, 1 );
+    memcpy( &wkb[1], &wkbtype, sizeof( int ) );
+    memcpy( &wkb[5], &x, sizeof( double ) );
+    memcpy( &wkb[5] + sizeof( double ), &y, sizeof( double ) );
 
-      QgsFeatureAction action( tr( "Feature added" ), *f, vlayer, -1, this );
-      if ( action.addFeature() )
-        mpCanvas->refresh();
+    f->setGeometryAndOwnership( &wkb[0], size );
 
-      delete f;
+    QgsFeatureAction action( tr( "Feature added" ), *f, vlayer, -1, this );
+    if ( action.addFeature() )
+    {
+      if ( mCbxAutoCommit->isChecked() )
+      {
+        // should canvas->isDrawing() be checked?
+        if ( !vlayer->commitChanges() ) //assumed to be vector layer and is editable and is in editing mode (preconditions have been tested)
+        {
+          QMessageBox::information( this,
+                                    tr( "Error" ),
+                                    tr( "Could not commit changes to layer %1\n\nErrors: %2\n" )
+                                    .arg( vlayer->name() )
+                                    .arg( vlayer->commitErrors().join( "\n  " ) ) );
+        }
+
+        vlayer->startEditing();
+      }
     }
-  }
+
+    delete f;
+  } // layerWKBType == QGis::WKBPoint
   else // Line or poly
   {
+    mNmea->disconnect(this, SLOT( displayGPSInformation( const QgsGPSInformation& ) ) );
+
     //create QgsFeature with wkb representation
     QgsFeature* f = new QgsFeature( 0, "WKBLineString" );
     unsigned char* wkb;
@@ -775,28 +1022,46 @@ void QgsGPSInformationWidget::on_mBtnCloseFeature_clicked( )
         return;
       }
     }
-    else //unknown type
+    // Should never get here, as preconditions should have removed any that aren't handled
+    else // layerWKBType == QGis::WKBPolygon  -  unknown type
     {
       QMessageBox::critical( 0, tr( "Error" ), tr( "Cannot add feature. "
                              "Unknown WKB type. Choose a different layer and try again." ) );
       connectGpsSlot();
       return; //unknown wkbtype
-    }
+    } // layerWKBType == QGis::WKBPolygon
 
     QgsFeatureAction action( tr( "Feature added" ), *f, vlayer, -1, this );
     if ( action.addFeature() )
-      mpCanvas->refresh();
+    {
+      if ( mCbxAutoCommit->isChecked() )
+      {
+        if ( !vlayer->commitChanges() ) //swiped... er... appropriated from QgisApp saveEdits()
+        {
+          QMessageBox::information( this,
+                                    tr( "Error" ),
+                                    tr( "Could not commit changes to layer %1\n\nErrors: %2\n" )
+                                    .arg( vlayer->name() )
+                                    .arg( vlayer->commitErrors().join( "\n  " ) ) );
+        }
+
+        vlayer->startEditing();
+      }
+      delete mpRubberBand;
+      mpRubberBand = NULL;
 
-    delete f;
+      // delete the elements of mCaptureList
+      mCaptureList.clear();
+    } // action.addFeature()
 
-    delete mpRubberBand;
-    mpRubberBand = NULL;
+    delete f;
+    connectGpsSlot();
+  } // layerWKBType == QGis::WKBPoint
+  mpCanvas->refresh();  // NOTE: cancelling feature add refreshes canvas, OK does not; this may change, however, so do it anyway
 
-    // delete the elements of mCaptureList
-    mCaptureList.clear();
-    mpCanvas->refresh();
-  }
-  connectGpsSlot();
+  // force focus back to GPS window/ Add Feature button for ease of use by keyboard
+  activateWindow();
+  mBtnCloseFeature->setFocus( Qt::OtherFocusReason );
 }
 
 void QgsGPSInformationWidget::connectGpsSlot( )
@@ -836,13 +1101,13 @@ void QgsGPSInformationWidget::createRubberBand( )
   {
     delete mpRubberBand;
   }
-  QSettings settings;
   mpRubberBand = new QgsRubberBand( mpCanvas, false );
-  setTrackColour();
-  mpRubberBand->setWidth( settings.value( "/gps/trackWidth", 2 ).toInt() );
+  mpRubberBand->setColor( mTrackColour );
+  mpRubberBand->setWidth( mSpinTrackWidth->value() );
   mpRubberBand->show();
 }
 
+#if 0 // this function isn't used
 QPointF QgsGPSInformationWidget::gpsToPixelPosition( const QgsPoint& point )
 {
   //transform to map crs
@@ -861,3 +1126,141 @@ QPointF QgsGPSInformationWidget::gpsToPixelPosition( const QgsPoint& point )
   mpCanvas->getCoordinateTransform()->transformInPlace( x, y );
   return QPointF( x, y ) ;
 }
+#endif
+
+void QgsGPSInformationWidget::on_mBtnLogFile_clicked()
+{
+//=========================
+  // This does not allow for an extension other than ".nmea"
+  // Retrieve last used log file dir from persistent settings
+  QSettings settings;
+  QString settingPath( "/gps/lastLogFileDir" );
+  QString lastUsedDir = settings.value( settingPath, "." ).toString();
+  QString saveFilePath = QFileDialog::getSaveFileName( this, tr( "Save GPS log file as" ), lastUsedDir, tr( "NMEA files (*.nmea)" ) );
+  if ( saveFilePath.isNull() ) //canceled
+  {
+    return;
+  }
+  QFileInfo myFI( saveFilePath );
+  QString myPath = myFI.path();
+  settings.setValue( settingPath, myPath );
+
+  // make sure the .nmea extension is included in the path name. if not, add it...
+  if ( "nmea" != myFI.suffix() )
+  {
+    saveFilePath = myFI.filePath() + ".nmea";
+  }
+  mTxtLogFile->setText( saveFilePath );
+  mTxtLogFile->setToolTip( saveFilePath );
+}
+
+void QgsGPSInformationWidget::logNmeaSentence( const QString& nmeaString )
+{
+  if ( mLogFileGroupBox->isChecked() && mLogFile && mLogFile->isOpen() )
+  {
+    mLogFileTextStream << nmeaString << "\r\n"; // specifically output CR + LF (NMEA requirement)
+  }
+}
+
+void QgsGPSInformationWidget::updateCloseFeatureButton( QgsMapLayer * lyr )
+{
+  QgsVectorLayer *vlayer = qobject_cast<QgsVectorLayer *>( lyr );
+
+  // Add feature button tracks edit state of layer
+  if ( vlayer != mpLastLayer )
+  {
+    if ( mpLastLayer )  // disconnect previous layer
+    {
+      disconnect( mpLastLayer, SIGNAL( editingStarted() ), this, SLOT( layerEditStateChanged() ) );
+      disconnect( mpLastLayer, SIGNAL( editingStopped() ), this, SLOT( layerEditStateChanged() ) );
+    }
+    if ( vlayer ) // connect new layer
+    {
+      connect( vlayer, SIGNAL( editingStarted() ), this, SLOT( layerEditStateChanged() ) );
+      connect( vlayer, SIGNAL( editingStopped() ), this, SLOT( layerEditStateChanged() ) );
+    }
+    mpLastLayer = vlayer;
+  }
+
+  QString buttonLabel = tr( "&Add feature" );
+  if ( vlayer ) // must be vector layer
+  {
+    QgsVectorDataProvider* provider = vlayer->dataProvider();
+    QGis::WkbType layerWKBType = vlayer->wkbType();
+
+    bool enable =
+      ( provider->capabilities() & QgsVectorDataProvider::AddFeatures ) &&  // layer can add features
+      vlayer->isEditable() && // layer is editing
+      ( // layer has geometry type that can be handled
+        layerWKBType == QGis::WKBPoint ||
+        layerWKBType == QGis::WKBLineString ||
+        layerWKBType == QGis::WKBPolygon
+        // add more types here as they are handled
+      )
+    ;
+    switch ( layerWKBType )
+    {
+      case QGis::WKBPoint:
+        buttonLabel = tr( "&Add Point" );
+        break;
+      case QGis::WKBLineString:
+        buttonLabel = tr( "&Add Line" );
+        break;
+      case QGis::WKBPolygon:
+        buttonLabel = tr( "&Add Polygon" );
+        break;
+      // for the future (also prevent compiler warnings)
+      case QGis::WKBMultiPoint:
+      case QGis::WKBMultiLineString:
+      case QGis::WKBMultiPolygon:
+      case QGis::WKBPoint25D:
+      case QGis::WKBLineString25D:
+      case QGis::WKBPolygon25D:
+      case QGis::WKBMultiPoint25D:
+      case QGis::WKBMultiLineString25D:
+      case QGis::WKBMultiPolygon25D:
+      case QGis::WKBUnknown:
+      case QGis::WKBNoGeometry:
+        ;
+    }
+    mBtnCloseFeature->setEnabled( enable );
+  }
+  else
+  {
+    mBtnCloseFeature->setEnabled( false );
+  }
+  mBtnCloseFeature->setText( buttonLabel );
+}
+
+void QgsGPSInformationWidget::layerEditStateChanged()
+{
+  updateCloseFeatureButton( mpLastLayer );
+}
+
+void QgsGPSInformationWidget::setStatusIndicator( const FixStatus statusValue )
+{
+  mLastFixStatus = statusValue;
+  // the pixmap will be expanded to the size of the label
+  QPixmap status( 4, 4 );
+  switch ( statusValue )
+  {
+    case NoFix:
+      status.fill( Qt::red );
+      break;
+    case Fix2D:
+      status.fill( Qt::yellow );
+      break;
+    case Fix3D:
+      status.fill( Qt::green );
+      break;
+    case NoData:
+    default: // anything else - shouldn't happen
+      status.fill( Qt::darkGray );
+  }
+  mLblStatusIndicator->setPixmap( status );
+}
+
+void QgsGPSInformationWidget::showStatusBarMessage( const QString& msg )
+{
+  QgisApp::instance()->statusBar()->showMessage( msg );
+}
diff --git a/src/app/gps/qgsgpsinformationwidget.h b/src/app/gps/qgsgpsinformationwidget.h
index 8d33522..e1bc5d4 100644
--- a/src/app/gps/qgsgpsinformationwidget.h
+++ b/src/app/gps/qgsgpsinformationwidget.h
@@ -29,7 +29,11 @@ class QextSerialPort;
 class QgsGPSConnection;
 class QgsGPSTrackerThread;
 struct QgsGPSInformation;
-class QPointF;
+//class QPointF;
+
+class QgsLegend;
+class QFile;
+class QColor;
 
 /**A dock widget that displays information from a GPS device and
  * allows the user to capture features using gps readings to
@@ -44,7 +48,10 @@ class QgsGPSInformationWidget: public QWidget, private Ui::QgsGPSInformationWidg
   private slots:
     void on_mConnectButton_toggled( bool theFlag );
     void displayGPSInformation( const QgsGPSInformation& info );
-    void setTrackColour( );
+    void logNmeaSentence( const QString& nmeaString ); // added to handle 'raw' data
+    void updateCloseFeatureButton( QgsMapLayer * lyr );
+    void layerEditStateChanged();
+ //   void setTrackColour( ); // no longer used
     void on_mBtnTrackColour_clicked( );
     void on_mSpinTrackWidth_valueChanged( int theValue );
     void on_mBtnPosition_clicked( );
@@ -56,17 +63,24 @@ class QgsGPSInformationWidget: public QWidget, private Ui::QgsGPSInformationWidg
     void on_mBtnAddVertex_clicked( );
     void on_mBtnCloseFeature_clicked( );
     void on_mBtnResetFeature_clicked( );
-    void on_mCbxAutoAddVertices_toggled( bool theFlag );
+// not needed    void on_mCbxAutoAddVertices_toggled( bool theFlag );
+    void on_mBtnLogFile_clicked();
 
     void connected( QgsGPSConnection * );
     void timedout();
 
   private:
+    enum FixStatus  //GPS status
+    {
+      NoData, NoFix, Fix2D, Fix3D
+    };
     void addVertex( );
     void connectGps();
     void connectGpsSlot( );
     void disconnectGps();
     void populateDevices();
+    void setStatusIndicator( const FixStatus statusValue );
+    void showStatusBarMessage( const QString& msg );
     QgsGPSConnection* mNmea;
     QgsMapCanvas * mpCanvas;
     QgsGpsMarker * mpMapMarker;
@@ -76,10 +90,17 @@ class QgsGPSInformationWidget: public QWidget, private Ui::QgsGPSInformationWidg
     QList< QwtPolarMarker * > mMarkerList;
     void createRubberBand( );
     QgsCoordinateReferenceSystem mWgs84CRS;
-    QPointF gpsToPixelPosition( const QgsPoint& point );
+// not used    QPointF gpsToPixelPosition( const QgsPoint& point );
     QgsRubberBand * mpRubberBand;
     QgsPoint mLastGpsPosition;
     QList<QgsPoint> mCaptureList;
+    FixStatus mLastFixStatus;
+    QString mDateTimeFormat; // user specified format string in registry (no UI presented)
+    QgsLegend * mpLegend;
+    QgsVectorLayer * mpLastLayer;
+    QFile * mLogFile;
+    QTextStream mLogFileTextStream;
+    QColor mTrackColour;
 };
 
 #endif // QGSGPSINFORMATIONWIDGET_H
diff --git a/src/app/gps/qgsgpsmarker.cpp b/src/app/gps/qgsgpsmarker.cpp
index e3544b4..551fcd1 100644
--- a/src/app/gps/qgsgpsmarker.cpp
+++ b/src/app/gps/qgsgpsmarker.cpp
@@ -14,7 +14,6 @@
  ***************************************************************************/
 
 #include <QPainter>
-#include <QSvgRenderer>
 
 #include "qgsgpsmarker.h"
 #include "qgscoordinatetransform.h"
@@ -27,6 +26,11 @@ QgsGpsMarker::QgsGpsMarker( QgsMapCanvas* mapCanvas )
 {
   mSize = 16;
   mWgs84CRS.createFromOgcWmsCrs( "EPSG:4326" );
+  mSvg.load( QString( ":/images/north_arrows/gpsarrow2.svg" ) );
+  if ( ! mSvg.isValid() )
+  {
+    qDebug( "GPS marker not found!" );
+  }
 }
 
 void QgsGpsMarker::setSize( int theSize )
@@ -60,14 +64,18 @@ void QgsGpsMarker::setCenter( const QgsPoint& point )
 
 void QgsGpsMarker::paint( QPainter* p )
 {
-  QSvgRenderer mySVG;
-  if ( !mySVG.load( QString( ":/images/north_arrows/gpsarrow2.svg" ) ) )
+  if ( ! mSvg.isValid() )
   {
-    qDebug( "GPS marker not found!" );
     return;
   }
+
+  // this needs to be done when the canvas is repainted to make for smoother map rendering
+  // if not done the map could be panned, but the cursor position won't be updated until the next valid GPS fix is received
+  QPointF pt = toCanvasCoordinates( mCenter );
+  setPos( pt );
+
   float myHalfSize = mSize / 2.0;
-  mySVG.render( p, QRectF( 0 - myHalfSize , 0 - myHalfSize, mSize, mSize ) );
+  mSvg.render( p, QRectF( 0 - myHalfSize , 0 - myHalfSize, mSize, mSize ) );
 }
 
 
diff --git a/src/app/gps/qgsgpsmarker.h b/src/app/gps/qgsgpsmarker.h
index fbeca42..cfc0d4d 100644
--- a/src/app/gps/qgsgpsmarker.h
+++ b/src/app/gps/qgsgpsmarker.h
@@ -19,6 +19,7 @@
 #include "qgsmapcanvasitem.h"
 #include "qgscoordinatereferencesystem.h"
 #include "qgspoint.h"
+#include <QSvgRenderer>
 
 class QPainter;
 
@@ -50,6 +51,7 @@ class QgsGpsMarker : public QgsMapCanvasItem
 
   private:
     QgsCoordinateReferenceSystem mWgs84CRS;
+    QSvgRenderer mSvg;
 
 };
 
diff --git a/src/app/qgisapp.cpp b/src/app/qgisapp.cpp
index 0143f87..10334cd 100755
--- a/src/app/qgisapp.cpp
+++ b/src/app/qgisapp.cpp
@@ -452,6 +452,18 @@ QgisApp::QgisApp( QSplashScreen *splash, bool restorePlugins, QWidget * parent,
   addDockWidget( Qt::LeftDockWidgetArea, mBrowserWidget );
   mBrowserWidget->hide();
 
+  // create the GPS tool on starting QGIS - this is like the Browser
+  mpGpsWidget = new QgsGPSInformationWidget( mMapCanvas );
+  //create the dock widget
+  mpGpsDock = new QDockWidget( tr( "GPS Information" ), this );
+  mpGpsDock->setObjectName( "GPSInformation" );
+  mpGpsDock->setAllowedAreas( Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea );
+  addDockWidget( Qt::LeftDockWidgetArea, mpGpsDock );
+  // add to the Panel submenu
+  // now add our widget to the dock - ownership of the widget is passed to the dock
+  mpGpsDock->setWidget( mpGpsWidget );
+  mpGpsDock->hide();
+
   mInternalClipboard = new QgsClipboard; // create clipboard
   mQgisInterface = new QgisAppInterface( this ); // create the interfce
 
@@ -630,6 +642,8 @@ QgisApp::~QgisApp()
 
   delete mPythonUtils;
 
+  delete mpGpsWidget;
+
   deletePrintComposers();
   removeAnnotationItems();
 
@@ -729,11 +743,6 @@ void QgisApp::readSettings()
   {
     showTileScale();
   }
-  // Restore state of GPS Tracker
-  if ( settings.value( "/gps/widgetEnabled", false ).toBool() )
-  {
-    showGpsTool();
-  }
 }
 
 
@@ -830,7 +839,6 @@ void QgisApp::createActions()
   connect( mActionSetLayerCRS, SIGNAL( triggered() ), this, SLOT( setLayerCRS() ) );
   connect( mActionSetProjectCRSFromLayer, SIGNAL( triggered() ), this, SLOT( setProjectCRSFromLayer() ) );
   connect( mActionTileScale, SIGNAL( triggered() ), this, SLOT( showTileScale() ) );
-  connect( mActionGpsTool, SIGNAL( triggered() ), this, SLOT( showGpsTool() ) );
   connect( mActionLayerProperties, SIGNAL( triggered() ), this, SLOT( layerProperties() ) );
   connect( mActionLayerSubsetString, SIGNAL( triggered() ), this, SLOT( layerSubsetString() ) );
   connect( mActionAddToOverview, SIGNAL( triggered() ), this, SLOT( isInOverview() ) );
@@ -1871,17 +1879,6 @@ void QgisApp::saveWindowState()
     settings.setValue( "/UI/tileScaleEnabled", false );
   }
 
-  // Persist state of GPS Tracker
-  if ( mpGpsWidget )
-  {
-    settings.setValue( "/gps/widgetEnabled", true );
-    delete mpGpsWidget;
-  }
-  else
-  {
-    settings.setValue( "/gps/widgetEnabled", false );
-  }
-
   QgsPluginRegistry::instance()->unloadAll();
 }
 
@@ -4518,28 +4515,6 @@ void QgisApp::setProjectCRSFromLayer()
   mMapCanvas->refresh();
 }
 
-void QgisApp::showGpsTool()
-{
-  if ( !mpGpsWidget )
-  {
-    mpGpsWidget = new QgsGPSInformationWidget( mMapCanvas );
-    //create the dock widget
-    mpGpsDock = new QDockWidget( tr( "GPS Information" ), this );
-    mpGpsDock->setObjectName( "GPSInformation" );
-    mpGpsDock->setAllowedAreas( Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea );
-    addDockWidget( Qt::LeftDockWidgetArea, mpGpsDock );
-    // add to the Panel submenu
-    mPanelMenu->addAction( mpGpsDock->toggleViewAction() );
-    // now add our widget to the dock - ownership of the widget is passed to the dock
-    mpGpsDock->setWidget( mpGpsWidget );
-    mpGpsWidget->show();
-  }
-  else
-  {
-    mpGpsDock->setVisible( mpGpsDock->isHidden() );
-  }
-}
-
 void QgisApp::showTileScale()
 {
   if ( !mpTileScaleWidget )
diff --git a/src/app/qgisapp.h b/src/app/qgisapp.h
index c6bcbad..6abb280 100644
--- a/src/app/qgisapp.h
+++ b/src/app/qgisapp.h
@@ -265,7 +265,6 @@ class QgisApp : public QMainWindow, private Ui::MainWindow
     QAction *actionSetLayerCRS() { return mActionSetLayerCRS; }
     QAction *actionSetProjectCRSFromLayer() { return mActionSetProjectCRSFromLayer; }
     QAction *actionTileScale() { return mActionTileScale; }
-    QAction *actionGpsTool() { return mActionGpsTool; }
     QAction *actionLayerProperties() { return mActionLayerProperties; }
     QAction *actionLayerSubsetString() { return mActionLayerSubsetString; }
     QAction *actionAddToOverview() { return mActionAddToOverview; }
@@ -483,8 +482,6 @@ class QgisApp : public QMainWindow, private Ui::MainWindow
     void setLayerCRS();
     //! Assign layer CRS to project
     void setProjectCRSFromLayer();
-    //! Show GPS tool
-    void showGpsTool();
     //! Show tile scale slider
     void showTileScale();
     //! zoom to extent of layer
diff --git a/src/core/gps/nmeatime.h b/src/core/gps/nmeatime.h
index b762a76..493da99 100644
--- a/src/core/gps/nmeatime.h
+++ b/src/core/gps/nmeatime.h
@@ -32,7 +32,7 @@ extern "C"
     int     hour;       /**< Hours since midnight - [0,23] */
     int     min;        /**< Minutes after the hour - [0,59] */
     int     sec;        /**< Seconds after the minute - [0,59] */
-    int     hsec;       /**< Hundredth part of second - [0,99] */
+    int     msec;       /**< Thousandths part of second - [0,999] */
 
   } nmeaTIME;
 
diff --git a/src/core/gps/parse.c b/src/core/gps/parse.c
index 518d26a..799c2a6 100644
--- a/src/core/gps/parse.c
+++ b/src/core/gps/parse.c
@@ -75,11 +75,22 @@ int _nmea_parse_time( const char *buff, int buff_sz, nmeaTIME *res )
                                  ) );
       break;
     case sizeof( "hhmmss.s" ) - 1:
+      success = ( 4 == nmea_scanf( buff, buff_sz,
+                                   "%2d%2d%2d.%d", &( res->hour ), &( res->min ), &( res->sec ), &( res->msec )
+                                 ) );
+      res->msec = res->msec * 100;   // tenths sec * 100 = thousandths
+      break;
     case sizeof( "hhmmss.ss" ) - 1:
+      success = ( 4 == nmea_scanf( buff, buff_sz,
+                                   "%2d%2d%2d.%d", &( res->hour ), &( res->min ), &( res->sec ), &( res->msec )
+                                 ) );
+      res->msec = res->msec * 10;   // hundredths sec * 10 = thousandths
+      break;
     case sizeof( "hhmmss.sss" ) - 1:
       success = ( 4 == nmea_scanf( buff, buff_sz,
-                                   "%2d%2d%2d.%d", &( res->hour ), &( res->min ), &( res->sec ), &( res->hsec )
+                                   "%2d%2d%2d.%d", &( res->hour ), &( res->min ), &( res->sec ), &( res->msec )
                                  ) );
+      // already thousandths
       break;
     default:
       nmea_error( "Parse of time error (format error)!" );
@@ -380,7 +391,7 @@ void nmea_GPGGA2info( nmeaGPGGA *pack, nmeaINFO *info )
   info->utc.hour = pack->utc.hour;
   info->utc.min = pack->utc.min;
   info->utc.sec = pack->utc.sec;
-  info->utc.hsec = pack->utc.hsec;
+  info->utc.msec = pack->utc.msec;
   info->sig = pack->sig;
   info->HDOP = pack->HDOP;
   info->elv = pack->elv;
diff --git a/src/core/gps/qextserialport/qextserialenumerator.h b/src/core/gps/qextserialport/qextserialenumerator.h
index 9503926..39c72d7 100644
--- a/src/core/gps/qextserialport/qextserialenumerator.h
+++ b/src/core/gps/qextserialport/qextserialenumerator.h
@@ -13,9 +13,14 @@
 
 #ifdef Q_OS_WIN
     #ifdef __MINGW32__
+      #ifdef _WIN32_WINNT
+        #if _WIN32_WINNT < 0x0500
+          #undef _WIN32_WINNT
+          #define _WIN32_WINNT 0x0500
+        #endif
+      #else
         #define _WIN32_WINNT 0x0500
-        #define _WIN32_WINDOWS 0x0500
-        #define WINVER 0x0500 
+      #endif
     #endif
     #include <windows.h>
     #include <setupapi.h>
diff --git a/src/core/gps/qgsgpsconnection.cpp b/src/core/gps/qgsgpsconnection.cpp
index 8ba805b..b341163 100644
--- a/src/core/gps/qgsgpsconnection.cpp
+++ b/src/core/gps/qgsgpsconnection.cpp
@@ -94,6 +94,13 @@ void QgsGPSConnection::clearLastGPSInformation()
   mLastGPSInformation.satellitesInView.clear();
   mLastGPSInformation.speed = 0;
   mLastGPSInformation.vdop = 0;
+  mLastGPSInformation.quality = -1;  // valid values: 0,1,2, maybe others
+  mLastGPSInformation.satellitesUsed = 0;
+  mLastGPSInformation.fixMode = ' ';
+  mLastGPSInformation.fixType = 0; // valid values: 1,2,3
+  mLastGPSInformation.status = ' '; // valid values: A,V
   mLastGPSInformation.utcDateTime.setDate( QDate() );
+  mLastGPSInformation.satPrn.clear();
   mLastGPSInformation.utcDateTime.setTime( QTime() );
+  mLastGPSInformation.satInfoComplete = false;
 }
diff --git a/src/core/gps/qgsgpsconnection.h b/src/core/gps/qgsgpsconnection.h
index 04a04c8..fd88151 100644
--- a/src/core/gps/qgsgpsconnection.h
+++ b/src/core/gps/qgsgpsconnection.h
@@ -20,6 +20,7 @@
 
 #include <QDateTime>
 #include <QObject>
+#include <QString>
 
 class QIODevice;
 
@@ -44,6 +45,13 @@ struct CORE_EXPORT QgsGPSInformation
   double hdop;
   double vdop;
   QDateTime utcDateTime;
+  QChar fixMode;
+  int fixType;
+  int quality;      // from GPGGA
+  int satellitesUsed; // from GPGGA
+  QChar status;     // from GPRMC A,V
+  QList<int>satPrn; // list of SVs in use; needed for QgsSatelliteInfo.inUse and other uses
+  bool satInfoComplete;  // based on GPGSV sentences - to be used to determine when to graph signal and satellite position
 };
 
 /**Abstract base class for connection to a GPS device*/
@@ -81,6 +89,7 @@ class CORE_EXPORT QgsGPSConnection : public QObject
 
   signals:
     void stateChanged( const QgsGPSInformation& info );
+    void nmeaSentenceReceived( const QString& substring );  // added to capture 'raw' data
 
   protected:
     /**Data source (e.g. serial device, socket, file,...)*/
diff --git a/src/core/gps/qgsgpsdetector.cpp b/src/core/gps/qgsgpsdetector.cpp
index 4ce739e..7535da3 100644
--- a/src/core/gps/qgsgpsdetector.cpp
+++ b/src/core/gps/qgsgpsdetector.cpp
@@ -89,7 +89,7 @@ QList< QPair<QString, QString> > QgsGPSDetector::availablePorts()
 QgsGPSDetector::QgsGPSDetector( QString portName )
 {
   mConn = 0;
-  mBaudList << BAUD4800 << BAUD9600 << BAUD38400;
+  mBaudList << BAUD4800 << BAUD9600 << BAUD38400 << BAUD57600;  //add 57600 for SXBlueII GPS unit
 
   if ( portName.isEmpty() )
   {
@@ -102,8 +102,6 @@ QgsGPSDetector::QgsGPSDetector( QString portName )
 
   mPortIndex = 0;
   mBaudIndex = -1;
-
-  advance();
 }
 
 QgsGPSDetector::~QgsGPSDetector()
